package com.castrianni.vcs;

import java.util.Date;
import java.io.IOException;

import com.intellij.openapi.vcs.history.VcsFileRevision;
import com.intellij.openapi.vcs.history.VcsRevisionNumber;
import com.intellij.openapi.vcs.VcsException;

public class VcsRevisionGraphRevision implements VcsFileRevision {
  protected VcsFileRevision _fileRevision = null;
  protected String _parentBranchId = null;

  public VcsRevisionGraphRevision(VcsFileRevision fileRevision,String parentBranchId)
  {
    _fileRevision = fileRevision;
    _parentBranchId = parentBranchId;
  }

  public String getParentBranchId()
  {
    return(_parentBranchId);
  }

  public VcsFileRevision getFileRevision()
  {
    return(_fileRevision);
  }

  public String getAuthor()
  {
    return(_fileRevision.getAuthor());
  }

  public String getBranchName()
  {
    return(_fileRevision.getBranchName());
  }

  public String getCommitMessage()
  {
    return(_fileRevision.getCommitMessage());
  }

  public Date getRevisionDate()
  {
    return(_fileRevision.getRevisionDate());
  }

  public VcsRevisionNumber getRevisionNumber()
  {
    return(_fileRevision.getRevisionNumber());
  }

  public byte[] getContent() throws IOException
  {
    return(_fileRevision.getContent());
  }

  public void loadContent() throws VcsException
  {
    _fileRevision.loadContent();
  }
}
